#include <machine/asmacros.h>

	.text
	SUPERALIGN_TEXT

#define	LA_VER	0x30		/* offset of the LAPIC version register */

#ifdef __amd64__
ENTRY(pushmmio)
	movq	lapic, %rax
	xor	%rcx, %rcx
1:	push	LA_VER(%rax)
	incq	%rcx		/* count number of pushes before faulting */
	jmp	1b
END(pushmmio)

ENTRY(pushmmio16)
	movq	lapic, %rax
	kor	%rcx, %rcx
1:	pushw	LA_VER(%rax)
	incq	%rcx
	jmp	1b
END(pushmmio16)
#else
ENTRY(pushmmio)
        movl    lapic, %eax
        xor     %ecx, %ecx
1:      push    LA_VER(%eax)
        inc     %ecx            /* count number of pushes before faulting */
        jmp     1b
END(pushmmio)

ENTRY(pushmmio16)
        movl    lapic, %eax
        xor     %ecx, %ecx
1:      pushw   LA_VER(%eax)
        inc     %ecx
        jmp     1b
END(pushmmio16)
#endif
